routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\ProductController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::resource('/product', ProductController::class);

app/Models/Category.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Category extends Model
{
    use HasFactory;
    public $fillable= ['id','name','description','active'];
    public $table='categories';

    public function products()
    {
        return $this->belongsToMany(Product::class);


    }
}

app/Models/Categoryproduct.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Categoryproduct extends Model
{
    use HasFactory;
    public $fillable= ['id','product_id','category_id'];
    public $table='category_product';

}

app/Models/Ordcomp.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Ordcomp extends Model
{
    use HasFactory;
    public $fillable= ['id','total','user_id','status_id'];

    public function user()
    {
        return $this->belongsTo(User::class);
    }

    public function status()
    {
        return $this->belongsTo(Status::class);
    }

    public function tickets(){
        return $this->hasMany(Ticket::class);
    }
}

app/Models/Photo.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Photo extends Model
{
    use HasFactory;
    public $fillable= ['id','name','extension','active','product_id'];

    public function product()
    {
        return $this->belongsTo(Product::class);
    }
}

app/Models/Product.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Product extends Model
{
    use HasFactory;

    public $fillable= ['id','name','description','price','active'];

   public function categories()
    {
        return $this->belongsToMany(Category::class);
    }

    public function tickets()
    {
        return  $this->belongsTo(Ticket::class);

    }
    public function photos()
    {
        return $this->hasMany(Photo::class);
    }


}

app/Models/Status.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Status extends Model
{
    use HasFactory;
    public $fillable= ['id','name'];

    public function ordcomps()
    {
        return $this->hasMany(Ordcomp::class);
    }
}

app/Models/Ticket.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Ticket extends Model
{
    use HasFactory;
    public $fillable= ['id','piece','amount','product_id','ordcomp_id'];

    public function products()
    {
        return $this->hasMany(Product::class);
    }

    public function ordcomp()
    {
        return $this->belongsTo(Ordcomp::class);
    }
}

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var string[]
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function ordcomps()
    {
        return $this->hasMany(Ordcomp::class);
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/ProductController.php
<?php

namespace App\Http\Controllers;

use App\Models\Product;
use Illuminate\Http\Request;

class ProductController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $Products= Product::with(['photos'])->get();
        return view('product.index',['Products'=>$Products,'title'=>"Mostrar productos"]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('product.create',['title'=>"Crear producto"]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $Product= new Product();
        $Product->name=$request->name;
        $Product->description=$request->description;
        $Product->price=$request->price;
        $Product->sku=$request->sku;
        $Product->save();
        return redirect()->route('product.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $Product = Product::with(['photos'])->find($id);
        return view('product.show',['Product'=>$Product,'title'=>"Mostrar producto $id"]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $Product = Product::find($id);
        return view('product.update',compact('Product'),['title'=>"Editar producto $id"]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $Product = Product::find($id);
        $Product->update($request->all());
        return redirect()->route('product.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/Http/Controllers/TestController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class TestController extends Controller
{
    //
}

resources/views/layouts/app.blade.php
<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>{{ $title ?? 'Todo Manager' }}</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">

</head>
<body>
    <h1>Esto viene de la plantilla </h1>
    @yield('content', 'Default content')
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p" crossorigin="anonymous"></script>
</body>
</html>

resources/views/product/create.blade.php
@extends('layouts.app')
@section('content')

    <h1>Crear producto</h1>
        <form action="{{route('product.store')}}" method="post">
            @csrf
            <p>nombre<input type="text" name="name"></p>
            <p>descripcion<input type="text" name="description"></p>
            <p>precio<input type="text" name="price"></p>
            <p>sku<input type="text" name="sku"></p>
            <p><button>enviar</button></p>
        </form>
@endsection

resources/views/product/index.blade.php
@extends('layouts.app')
@section('content')
    <h1>Productos</h1>
    <table>
        <thead>
            <tr>
                <th>id</th>
                <th>nombre</th>
                <th>descripcion</th>
                <th>precio</th>
                <th>sku</th>
                <th>editar</th>

            </tr>
        </thead>
        <tbody>
            @foreach ( $Products as $Product )
            <tr>
                <td>{{ $Product->id }}</td>
                <td>{{ $Product->name}}</td>
                <td>{{$Product->description}}</td>
                <td>{{$Product->price}}</td>
                <td>{{ $Product->sku }}</td>
                <td><a href="{{route('product.edit',[$Product->id])}}"> Editar</a></td>
                <td><a href="{{route('product.show',[$Product->id])}}"> Mostrar </a></td>
            </tr>
            @endforeach
        </tbody>
    </table>
    @endsection

resources/views/product/show.blade.php
@extends('layouts.app')

@section('content')
    <h1>Mostrar Producto {{$Product->id}}</h1>

        <p>nombre {{ $Product->name }}</p>
        <p>descripcion {{ $Product->description}}</p>
        <p>precio {{$Product->price}} </p>
        <p>sku {{$Product->sku}}</p>
        <h2>aqui van las fotos </h2>

        @foreach ($Product->photos as $photo )
            <p><img src="{{asset('/photos/'.$photo->name)}}" alt="{{$photo->name}}"></p>

        @endforeach
@endsection

resources/views/product/update.blade.php
@extends('layouts.app')
@section('content')

    <h1>Actualizar Producto</h1>
    <form action="{{route('product.update',[$Product->id])}}" method="post">
        @csrf
        {{ method_field('PUT') }}
        <p>nombre<input type="text" name="name" value="{{ $Product->name }}"></p>
        <p>descripcion<input type="text" name="description" value="{{ $Product->description}}"></p>
        <p>precio<input type="text" name="price"  value="{{$Product->price}}"></p>
        <p>sku<input type="text" name="sku" value="{{$Product->sku}}"></p>
        <p><button>enviar</button></p>
    </form>
@endsection